image: docker:18.09.7

stages:
  - build_develop
  - build_release
  - build_stage
  - build_prod
  - deploy
services:
  - docker:18.09.7-dind


  
# NON EXECUTABLE BUILD TEMPLATE #
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
.execute_build_lifecycle: &execute_build_lifecycle
  stage: build
  variables:
    IMAGE_TAG: latest
    DOCKER_HOST: tcp://localhost:2375
  before_script:
    - |
      if [ -z "$PLUGINS_IMAGE_REF" ]; then
        export PLUGINS_IMAGE_REF=$REGISTRY/$GROUP/$DCR_ENV_REPO/plugins:latest;
      fi;
    - echo $DOCKER_PASSWORD > ~/login_pass.txt

  script:
    - cat ~/login_pass.txt | docker login -u $DOCKER_USER --password-stdin https://$REGISTRY
    - |
      docker build \
      --build-arg PLUGINS_IMAGE_REF=$PLUGINS_IMAGE_REF \
      --tag $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:$IMAGE_TAG .
    - docker push $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:$IMAGE_TAG
    - | 
      if [ "$DCR_ENV_REPO" == "stage" ] || [ "$DCR_ENV_REPO" == "prod" ]; then
        docker build \
        --build-arg PLUGINS_IMAGE_REF=$PLUGINS_IMAGE_REF \
        --tag $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:latest .
        docker push $REGISTRY/$GROUP/$DCR_ENV_REPO/$IMAGE_NAME:latest
      fi 

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #

build_develop: 
  <<: *execute_build_lifecycle
  stage: build_develop
  variables:
    IMAGE_TAG: latest
    ENV: $CI_COMMIT_REF_NAME
    DOCKER_HOST: tcp://localhost:2375
  only:
    variables:
      - $BUILD == "develop"

build_release:
  <<: *execute_build_lifecycle 
  stage: build_release
  variables:
    IMAGE_TAG: latest
    ENV: $CI_COMMIT_REF_NAME
    DOCKER_HOST: tcp://localhost:2375
  only:
    variables:
      - $BUILD == "release"

  
build_stage:
  <<: *execute_build_lifecycle 
  stage: build_stage
  variables:
    ENV: stage
    IMAGE_TAG: $CI_COMMIT_SHORT_SHA
    DOCKER_HOST: tcp://localhost:2375
  only:
    variables:
      - $BUILD == "stage"

build_prod:
  <<: *execute_build_lifecycle 
  stage: build_prod
  variables:
    ENV: prod
    IMAGE_TAG: $CI_COMMIT_SHORT_SHA
    DOCKER_HOST: tcp://localhost:2375
  only:
    variables:
      - $BUILD == "prod"


deploy: 
  stage: deploy
  script: 
    - apk add --no-cache curl
    - | 
      curl -X POST \
      -F token=$DEVOPS_CI_JOB_TOKEN \
      -F ref=master \
      -F "variables[SERVICE]=graph" \
      -F "variables[STACK]=reindex-stack" \
      -F "variables[ENV]=$BUILD" \
      https://gitlab.linnovate.net/api/v4/projects/${DEVOPS_ID}/trigger/pipeline
  only:
    variables:
      - $BUILD == "develop" || $BUILD == "release" && $DEVOPS_ID && $DEVOPS_CI_JOB_TOKEN


